package net.voltexstudios;

import net.fabricmc.api.ClientModInitializer;
import net.fabricmc.fabric.api.blockrenderlayer.v1.BlockRenderLayerMap;
import net.fabricmc.fabric.api.client.rendering.v1.EntityModelLayerRegistry;
import net.fabricmc.fabric.api.client.rendering.v1.EntityRendererRegistry;
import net.minecraft.client.render.RenderLayer;
import net.voltexstudios.blocks.ModBlocks;
import net.voltexstudios.entity.ModEntities;
import net.voltexstudios.entity.client.bandit.BanditModel;
import net.voltexstudios.entity.client.bandit.BanditRenderer;
import net.voltexstudios.entity.client.cobra.CobraModel;
import net.voltexstudios.entity.client.cobra.CobraRenderer;
import net.voltexstudios.entity.client.mummy.MummyModel;
import net.voltexstudios.entity.client.mummy.MummyRenderer;
import net.voltexstudios.entity.client.vulture.VultureModel;
import net.voltexstudios.entity.client.vulture.VultureRenderer;


public class VoltexDesertUpdateClient implements ClientModInitializer {
    @Override
    public void onInitializeClient() {
        VoltexDesertUpdate.LOGGER.info("Initializing Desert Update Client");

        BlockRenderLayerMap.INSTANCE.putBlock(ModBlocks.PALM_SAPLING, RenderLayer.getCutout());

        EntityModelLayerRegistry.registerModelLayer(VultureModel.VULTURE, VultureModel::getTexturedModelData);
        EntityModelLayerRegistry.registerModelLayer(BanditModel.BANDIT, BanditModel::getTexturedModelData);
        EntityModelLayerRegistry.registerModelLayer(CobraModel.COBRA, CobraModel::getTexturedModelData);
        EntityModelLayerRegistry.registerModelLayer(MummyModel.MUMMY, MummyModel::getTexturedModelData);
        EntityRendererRegistry.register(ModEntities.VULTURE_ENTITY, VultureRenderer::new);
        EntityRendererRegistry.register(ModEntities.BANDIT_ENTITY, BanditRenderer::new);
        EntityRendererRegistry.register(ModEntities.COBRA_ENTITY, CobraRenderer::new);
        EntityRendererRegistry.register(ModEntities.MUMMY_ENTITY, MummyRenderer::new);
    }
}
