package net.voltexstudios.datagen;

import net.fabricmc.fabric.api.datagen.v1.FabricDataOutput;
import net.fabricmc.fabric.api.datagen.v1.provider.FabricModelProvider;
import net.minecraft.data.client.BlockStateModelGenerator;
import net.minecraft.data.client.ItemModelGenerator;
import net.minecraft.data.client.Models;
import net.minecraft.data.client.TexturedModel;
import net.voltexstudios.blocks.ModBlocks;
import net.voltexstudios.item.ModItems;

public class ModModelProvider extends FabricModelProvider {

    public ModModelProvider(FabricDataOutput output) {
        super(output);
    }

    @Override
    public void generateBlockStateModels(BlockStateModelGenerator blockStateModelGenerator) {
        blockStateModelGenerator.registerLog(ModBlocks.PALM_LOG).log(ModBlocks.PALM_LOG).wood(ModBlocks.PALM_WOOD);

        blockStateModelGenerator.registerSimpleCubeAll(ModBlocks.QUICKSAND_BLOCK);
        blockStateModelGenerator.registerSimpleCubeAll(ModBlocks.PALM_PLANKS);
        blockStateModelGenerator.registerSingleton(ModBlocks.PALM_LEAVES, TexturedModel.LEAVES);
        blockStateModelGenerator.registerTintableCrossBlockState(ModBlocks.PALM_SAPLING, BlockStateModelGenerator.TintType.NOT_TINTED);

        blockStateModelGenerator.registerSimpleCubeAll(ModBlocks.WIPED_SAND_SHADE_1);
        blockStateModelGenerator.registerSimpleCubeAll(ModBlocks.WIPED_SAND_SHADE_2);
        blockStateModelGenerator.registerSimpleCubeAll(ModBlocks.SANDSTONE_BRICKS);
        blockStateModelGenerator.registerSimpleCubeAll(ModBlocks.SANDSTONE_TILE_BRICKS);
        blockStateModelGenerator.registerSimpleCubeAll(ModBlocks.SANDSTONE_ROCK_SHADE_1);
        blockStateModelGenerator.registerSimpleCubeAll(ModBlocks.SANDSTONE_ROCK_SHADE_2);
        blockStateModelGenerator.registerSimpleCubeAll(ModBlocks.SANDSTONE_ROCK_SHADE_3);
        blockStateModelGenerator.registerSimpleCubeAll(ModBlocks.SANDSTONE_ROCK_SHADE_4);
        blockStateModelGenerator.registerSimpleCubeAll(ModBlocks.SANDSTONE_ROCK_SHADE_5);
        blockStateModelGenerator.registerSimpleCubeAll(ModBlocks.SANDSTONE_ROCK_SHADE_6);
        blockStateModelGenerator.registerSimpleCubeAll(ModBlocks.SANDSTONE_ROCK_SHADE_7);
        blockStateModelGenerator.registerSimpleCubeAll(ModBlocks.SANDSTONE_ROCK_SHADE_8);
    }

    @Override
    public void generateItemModels(ItemModelGenerator itemModelGenerator) {
        itemModelGenerator.register(ModBlocks.PALM_SAPLING.asItem(), Models.GENERATED);

        // Registering items
        itemModelGenerator.register(ModItems.SABER, Models.HANDHELD);
        itemModelGenerator.register(ModItems.DUNE_STAFF, Models.GENERATED);
    }
}
