package net.voltexstudios.entity;

import net.minecraft.entity.EntityType;
import net.minecraft.entity.SpawnGroup;
import net.minecraft.registry.Registries;
import net.minecraft.registry.Registry;
import net.minecraft.util.Identifier;
import net.voltexstudios.VoltexDesertUpdate;
import net.voltexstudios.entity.custom.*;

public class ModEntities {

    //TODO alter dimensions
    public static final EntityType<VultureEntity> VULTURE_ENTITY = Registry.register(Registries.ENTITY_TYPE,
            Identifier.of(VoltexDesertUpdate.MOD_ID, "vulture_entity"),
            EntityType.Builder.create(VultureEntity::new, SpawnGroup.CREATURE)
                    .dimensions(0.75f, 1f).build());

    public static final EntityType<DuneProjectileEntity> DUNE_PROJECTILE_ENTITY = Registry.register(Registries.ENTITY_TYPE,
            Identifier.of(VoltexDesertUpdate.MOD_ID, "dune_projectile_entity"),
            EntityType.Builder.<DuneProjectileEntity>create(DuneProjectileEntity::new, SpawnGroup.MISC)
                    .dimensions(0.25f, 0.25f).build());

    public static final EntityType<BanditEntity> BANDIT_ENTITY = Registry.register(Registries.ENTITY_TYPE,
            Identifier.of(VoltexDesertUpdate.MOD_ID, "bandit_entity"),
            EntityType.Builder.create(BanditEntity::new, SpawnGroup.CREATURE)
                    .dimensions(0.5f, 2f).build());

    public static final EntityType<CobraEntity> COBRA_ENTITY = Registry.register(Registries.ENTITY_TYPE,
            Identifier.of(VoltexDesertUpdate.MOD_ID, "cobra_entity"),
            EntityType.Builder.create(CobraEntity::new, SpawnGroup.CREATURE)
                    .dimensions(0.5f, 0.8f).build());

    public static final EntityType<MummyEntity> MUMMY_ENTITY = Registry.register(Registries.ENTITY_TYPE,
            Identifier.of(VoltexDesertUpdate.MOD_ID, "mummy_entity"),
            EntityType.Builder.create(MummyEntity::new, SpawnGroup.CREATURE)
                    .dimensions(0.5f, 2f).build());

    public static void registerModEntities() {
        VoltexDesertUpdate.LOGGER.info("Registering Mod Entities for " + VoltexDesertUpdate.MOD_ID);
    }
}
