package net.voltexstudios.entity.client.bandit;

import net.minecraft.client.render.VertexConsumerProvider;
import net.minecraft.client.render.entity.EntityRendererFactory;
import net.minecraft.client.render.entity.MobEntityRenderer;
import net.minecraft.client.render.entity.feature.HeldItemFeatureRenderer;
import net.minecraft.client.render.entity.model.IllagerEntityModel;
import net.minecraft.client.util.math.MatrixStack;
import net.minecraft.entity.mob.VindicatorEntity;
import net.minecraft.util.Identifier;
import net.voltexstudios.VoltexDesertUpdate;
import net.voltexstudios.entity.custom.BanditEntity;

public class BanditRenderer extends MobEntityRenderer<BanditEntity, BanditModel<BanditEntity>> {

    public BanditRenderer(EntityRendererFactory.Context context) {
        super(context, new BanditModel<>(context.getPart(BanditModel.BANDIT)), 0.5f);
        this.addFeature(
                new HeldItemFeatureRenderer<>(this, context.getHeldItemRenderer()) {
                    public void render(
                            MatrixStack matrixStack,
                            VertexConsumerProvider vertexConsumerProvider,
                            int i,
                            BanditEntity banditEntity,
                            float f,
                            float g,
                            float h,
                            float j,
                            float k,
                            float l
                    ) {
                        if (banditEntity.isAttacking()) {
                            matrixStack.push();

                            // Adjust the position of the item to the hand
                            if (banditEntity.isLeftHanded()) {
                                matrixStack.translate(0.0625, 1.3, 0.0625); // Adjust these values as needed
                            } else {
                                matrixStack.translate(-0.0625, 1.3, 0.0625); // Adjust these values as needed
                            }

                            super.render(matrixStack, vertexConsumerProvider, i, banditEntity, f, g, h, j, k, l);
                            matrixStack.pop();
                        }
                    }
                }
        );
    }

    @Override
    public Identifier getTexture(BanditEntity entity) {
        return Identifier.of(VoltexDesertUpdate.MOD_ID, "textures/entity/bandit/bandit.png");
    }

    @Override
    public void render(BanditEntity livingEntity, float f, float g, MatrixStack matrixStack, VertexConsumerProvider vertexConsumerProvider, int i) {
        if(livingEntity.isBaby()) {
            matrixStack.scale(0.5f, 0.5f, 0.5f);
        } else {
            matrixStack.scale(1f, 1f, 1f);
        }

        super.render(livingEntity, f, g, matrixStack, vertexConsumerProvider, i);
    }
}
