package net.voltexstudios.entity.client.cobra;

import net.minecraft.client.render.VertexConsumerProvider;
import net.minecraft.client.render.entity.EntityRendererFactory;
import net.minecraft.client.render.entity.MobEntityRenderer;
import net.minecraft.client.util.math.MatrixStack;
import net.minecraft.util.Identifier;
import net.voltexstudios.VoltexDesertUpdate;
import net.voltexstudios.entity.custom.CobraEntity;

public class CobraRenderer extends MobEntityRenderer<CobraEntity, CobraModel<CobraEntity>> {

    public CobraRenderer(EntityRendererFactory.Context context) {
        super(context, new CobraModel<>(context.getPart(CobraModel.COBRA)), 0.5f);
    }

    @Override
    public Identifier getTexture(CobraEntity entity) {
        return Identifier.of(VoltexDesertUpdate.MOD_ID, "textures/entity/cobra/cobra.png");
    }

    @Override
    public void render(CobraEntity livingEntity, float f, float g, MatrixStack matrixStack, VertexConsumerProvider vertexConsumerProvider, int i) {
        if(livingEntity.isBaby()) {
            matrixStack.scale(0.5f, 0.5f, 0.5f);
        } else {
            matrixStack.scale(1f, 1f, 1f);
        }

        super.render(livingEntity, f, g, matrixStack, vertexConsumerProvider, i);
    }
}
