package net.voltexstudios.entity.client.mummy;

import net.minecraft.client.render.VertexConsumerProvider;
import net.minecraft.client.render.entity.EntityRendererFactory;
import net.minecraft.client.render.entity.MobEntityRenderer;
import net.minecraft.client.util.math.MatrixStack;
import net.minecraft.util.Identifier;
import net.voltexstudios.VoltexDesertUpdate;
import net.voltexstudios.entity.custom.MummyEntity;

public class MummyRenderer extends MobEntityRenderer<MummyEntity, MummyModel<MummyEntity>> {

    public MummyRenderer(EntityRendererFactory.Context context) {
        super(context, new MummyModel<>(context.getPart(MummyModel.MUMMY)), 0.5f);
    }

    @Override
    public Identifier getTexture(MummyEntity entity) {
        return Identifier.of(VoltexDesertUpdate.MOD_ID, "textures/entity/mummy/mummy.png");
    }

    @Override
    public void render(MummyEntity livingEntity, float f, float g, MatrixStack matrixStack, VertexConsumerProvider vertexConsumerProvider, int i) {
        if(livingEntity.isBaby()) {
            matrixStack.scale(0.5f, 0.5f, 0.5f);
        } else {
            matrixStack.scale(1f, 1f, 1f);
        }

        super.render(livingEntity, f, g, matrixStack, vertexConsumerProvider, i);
    }
}
