package net.voltexstudios.entity.custom;

import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityType;
import net.minecraft.entity.LivingEntity;
import net.minecraft.entity.projectile.thrown.ThrownItemEntity;
import net.minecraft.item.Item;
import net.minecraft.item.Items;
import net.minecraft.particle.ParticleTypes;
import net.minecraft.util.hit.EntityHitResult;
import net.minecraft.util.hit.HitResult;
import net.minecraft.world.World;

public class DuneProjectileEntity extends ThrownItemEntity {

    private static final float DAMAGE = 4F;

    public DuneProjectileEntity(EntityType<DuneProjectileEntity> duneProjectileEntityEntityType, World world) {
        super(duneProjectileEntityEntityType, world);
    }

    public DuneProjectileEntity(LivingEntity livingEntity, World world) {
        super(EntityType.EGG, livingEntity, world);
    }

    @Override
    public void tick() {
        super.tick();
        System.out.println("Entity ID: " + this.getId()); // Debug-Nachricht
        World world = this.getWorld();
        if (world.isClient) {
            System.out.println("Spawning particles on client!"); // Debug-Nachricht
            for (int i = 0; i < 5; i++) {
                world.addParticle(
                        ParticleTypes.FLAME,
                        this.getX() + (random.nextDouble() - 0.5) * 0.5,
                        this.getY() + (random.nextDouble() - 0.5) * 0.5,
                        this.getZ() + (random.nextDouble() - 0.5) * 0.5,
                        0.0D,
                        0.0D,
                        0.0D
                );
            }
        }
    }

    @Override
    protected void onCollision(HitResult hitResult) {
        super.onCollision(hitResult);
        if (!this.getWorld().isClient) {
            this.getWorld().createExplosion(this, this.getX(), this.getBodyY(0.0625D), this.getZ(), 1.0F, false, World.ExplosionSourceType.TRIGGER);
            this.discard();
        }
    }

    @Override
    protected void onEntityHit(EntityHitResult entityHitResult) {
        super.onEntityHit(entityHitResult);
        Entity entity = entityHitResult.getEntity();
        entity.damage(this.getDamageSources().thrown(this, this.getOwner()), DAMAGE);
        this.discard();
    }


    @Override
    protected Item getDefaultItem() {
        return Items.EGG;
    }

}
