package net.voltexstudios.item;

import net.fabricmc.fabric.api.itemgroup.v1.ItemGroupEvents;
import net.minecraft.item.*;
import net.minecraft.registry.Registries;
import net.minecraft.registry.Registry;
import net.minecraft.util.Identifier;
import net.minecraft.util.Rarity;
import net.voltexstudios.VoltexDesertUpdate;
import net.voltexstudios.item.custom.DuneStaffItem;
import net.voltexstudios.item.custom.SaberItem;

public class ModItems {

    public static final Item DUNE_STAFF = registerItem("dune_staff", new DuneStaffItem(new Item.Settings()
            .rarity(Rarity.EPIC)
            .maxDamage(100)
            .fireproof()
    ));

    public static final Item SABER = registerItem("saber", new SaberItem(ToolMaterials.IRON, new Item.Settings()
            .attributeModifiers(
                    SwordItem.createAttributeModifiers(ToolMaterials.IRON, 3, -2.4F)
            )
    ));

    private static Item registerItem(String name, Item item) {
        return Registry.register(Registries.ITEM, Identifier.of(VoltexDesertUpdate.MOD_ID, name), item);
    }

    public static void registerModItems() {
        VoltexDesertUpdate.LOGGER.info("Registering Mod Items for " + VoltexDesertUpdate.MOD_ID);

        ItemGroupEvents.modifyEntriesEvent(ItemGroups.TOOLS).register(entries -> {
            // add items to the ingredients tab
            entries.add(DUNE_STAFF);
            entries.add(SABER);
        });
    }
}
